--[[-------------------------------------------------------------------------
	DinnerBell
	Copyright (C) 2010-2011  Morsker
	Please contact Morsker through PM on forums.wowace.com.

	Plays a sound in response to Fish Feasts and other feasts.

	This program is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program. If not, see <http://www.gnu.org/licenses/>.
---------------------------------------------------------------------------]]
local addonName = ...
local Addon = LibStub("AceAddon-3.0"):NewAddon(addonName, "AceEvent-3.0")
_G[addonName] = Addon

-- GLOBALS: InCombatLockdown
-- GLOBALS: PlaySoundFile
-- GLOBALS: AnimTimerFrame
-- GLOBALS: GetCVar
-- GLOBALS: SetCVar
local _G = _G

Addon.soundPath = "Sound\\Doodad\\SimonGame_LargeBlueTree.wav"

Addon.feastIDs = {
	[57301] = 1, -- Great Feast (WotLK)
	[57426] = 1, -- Fish Feast (WotLK)
	[66476] = 1, -- Bountiful Feast (Pilgrim's Bounty)
	[87643] = 1, -- Broiled Dragon Feast (Cata)
	[87644] = 1, -- Seafood Magnifique Feast (Cata)
	[87915] = 1, -- Goblin Barbecue (Cata)
	[104958] = 1, -- Pandaren Banquet (MoP)
	[105193] = 1, -- Great Pandaren Banquet (MoP)
	[126492] = 1, -- Banquet of the Grill (MoP)
	[126494] = 1, -- Great Banquet of the Grill (MoP)
	[126495] = 1, -- Banquet of the Wok (MoP)
	[126496] = 1, -- Great Banquet of the Wok (MoP)
	[126497] = 1, -- Banquet of the Pot (MoP)
	[126498] = 1, -- Great Banquet of the Pot (MoP)
	[126499] = 1, -- Banquet of the Steamer (MoP)
	[126500] = 1, -- Great Banquet of the Steamer (MoP)
	[126501] = 1, -- Banquet of the Oven (MoP)
	[126502] = 1, -- Great Banquet of the Oven (MoP)
	[126503] = 1, -- Banquet of the Brew (MoP)
	[126504] = 1, -- Great Banquet of the Brew (MoP)
}
local feastIDs = Addon.feastIDs

function Addon:COMBAT_LOG_EVENT_UNFILTERED(event, timestamp, eventtype, ...)
	if eventtype == "SPELL_CAST_START" then
		local _,_,_,_,_,_,_,_,_,spellid = ...
		if feastIDs[spellid] then
			PlaySoundFile(self.soundPath, "Master")
		end
	end
end

function Addon:PLAYER_REGEN_DISABLED()
	self:UnregisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

function Addon:PLAYER_REGEN_ENABLED()
	self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
end

function Addon:OnInitialize()
	self.OnInitialize = nil
end

function Addon:OnEnable()
	if not InCombatLockdown() then
		self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
	end
	self:RegisterEvent("PLAYER_REGEN_DISABLED")
	self:RegisterEvent("PLAYER_REGEN_ENABLED")
end

function Addon:OnDisable()
end
